%define buildup 1
%define buildsmp 0
%define buildpae 1
%define all_x86 i686
%define sublevel 26
%define subrel 3 
%define kversion 2.6.%{sublevel}
%define rpmversion 2.6.%{sublevel}
%define KVERREL %{PACKAGE_VERSION}-%{PACKAGE_RELEASE}.%{_target_cpu}
%define hdrarch %_target_cpu
%define make_target bzImage
%define kernel_image x86
%define buildheaders 1

%ifarch %{all_x86}
%define all_arch_configs $RPM_SOURCE_DIR/kernel-%{kversion}-i?86*.config
%define image_install_path boot
%define signmodules 1
%define hdrarch i386
%endif
%ifarch x86_64
%define all_arch_configs $RPM_SOURCE_DIR/kernel-%{kversion}-x86_64*.config
%define image_install_path boot
%define signmodules 1
%endif

#
# Packages that need to be installed before the kernel is, because the %post
# scripts use them.
#
%define kernel_prereq  module-init-tools udev ccux-geninitramfs v86d

#
# This macro does requires, provides, conflicts, obsoletes for a kernel package.
#       %%kernel_reqprovconf <subpackage>
# It uses any kernel_<subpackage>_conflicts and kernel_<subpackage>_obsoletes
# macros defined above.
#
%define kernel_reqprovconf \
Provides:       kernel = %{version}-%{release}\
Provides:       kernel-%{_target_cpu}%{?1:.%{1}} = %{kversion}-%{release}\
Requires(pre): %{kernel_prereq}\
%{?1:%{expand:%%{?kernel_%{1}_conflicts:Conflicts: %%{kernel_%{1}_conflicts}}}}\
%{?1:%{expand:%%{?kernel_%{1}_obsoletes:Obsoletes: %%{kernel_%{1}_obsoletes}}}}\
%{?1:%{expand:%%{?kernel_%{1}_provides:Provides: %%{kernel_%{1}_provides}}}}\
# We can't let RPM do the dependencies automatic because it'll then pick up\
# a correct but undesirable perl dependency from the module headers which\
# isn't required for the kernel proper to function\
AutoReq: no\
AutoProv: yes\
%{nil}


Distribution:	CCux
Packager:  	Christian Metzen <metzench@ccux-linux.de>

Summary:   	The kernel (core of the operating system - device drivers etc.)
Name:      	kernel%{?variant}
Version:   	%{kversion}
Release:   	9
ExclusiveArch:	%{all_x86} x86_64
%kernel_reqprovconf
Provides: 	kernel-%{_target_cpu}%{?variant:.%{variant}} = %{kversion}-%{release}
BuildRoot:      %{_tmppath}/%{name}-buildroot
Requires:       ccux-bootscripts >= 1.3.0 udev >= 079
Requires:       ccux-geninitramfs >= 1:0.0.1-1
BuildRequires:  sharutils
Obsoletes:      fuse
Obsoletes:      ccux-bootsplash <= 1.3.1-2
License: 	GPLv2
URL:		http://www.kernel.org
Group:     	System/Kernel
#Source0:	linux-2.6.%{sublevel}.tar.bz2
Source0:        linux-2.6.%{sublevel}.%{subrel}.tar.bz2
Source20:	kernel-%{version}-i686.config
Source21:	kernel-%{version}-i686-PAE.config
# base patches

# honor quiet kerneloption, shut off decompressor messages 
# patch taken from feodora kernel, combined and rediffed
Patch0: 	linux-2.6-honor-quiet-option.patch

# Con Kolivas optimizations
# patch found at http://forums.gentoo.org/viewtopic-t-596069-postdays-0-postorder-asc-start-0.html
Patch1:	 	ckpatches-2.6.24.patch
Patch2:  	sched-cfs-boost-2.6.24.patch
Patch3:  	sched-cfs-tunables-2.6.24-rc4.patch
# set compile mtune option to generic for optimized builds
Patch4:	 	linux-2.6-x86-tune-generic.patch

# turn on relatime as default mount option
# should give a vast performance boost on systems without noatime partitions
# while at the same time preventing breaking mail programs like mutt
#Patch5:  linux-2.6-smarter-relatime.patch upstream ?

# hotfixpatches 

# Acer hotkey support
# Based on acerhk 0.5.35 (http://www.cakey.de/acerhk/)
Patch212:	linux-2.6.20-acerhk.patch
# Acer ACPI extras
Patch213:       acer-acpi-2.6.24.patch
# Fujitsu ACPI extras
Patch214:	fujitsu-laptop-extras-2.6.24.patch

# uvesafb http://dev.gentoo.org/~spock/projects/uvesafb/
#Patch91001:     uvesafb-0.1-rc3-2.6.23-rc3.patch => upstream
Patch91002:	fbcondecor-0.9.4-2.6.25-rc6.patch
# Kernel Colors
# http://lkml.org/lkml/2007/10/5/199
Patch91003:	kernel-colors.patch
# reiser4 filesystem support
# taken from http://www.kernel.org/pub/linux/kernel/people/edward/reiser4/reiser4-for-2.6/
Patch7006:	reiser4-for-2.6.25.patch

# UML skas patch
#Patch7009:	skas4.patch

# tuxonice software suspend to disk
# http://www.tuxonice.net/
# edited to fit ck-patch
Patch7011:	tuxonice-3.0-rc7a-for-2.6.26.patch

# atop 
# http://www.atcomputing.nl/Tools/atop/
# edited for .24
Patch7020:	01patch-2.6.25_atopcnt
Patch7021:	02patch-2.6.25_atopacct

# add ALSA 1.0.17rc1 drivers
# create patch according to http://gentoo-wiki.com/HOWTO_Compile_Kernel_with_ALSA#Patch_kernel_with_live_ALSA_.28optional.29
# from alsa-driver-1.0.17.tar.bz2 source
# i2c_ids.h files need to be combined not overwritten !
# additionally http://ring.u-toyama.ac.jp/archives/linux/kernel.org/kernel/people/gregkh/driver_core/2.6/2.6.26-rc3/driver-core-add-device_create_vargs-and-device_create_drvdata.patch
# and http://thread.gmane.org/gmane.linux.kernel.cross-arch/166
# is needed
#Patch8000:	linux-2.6-alsa1017.patch upstream 2.6.26.1


# Tweak some defaults.
Patch2101: 	linux-2.6-defaults-fat-utf8.patch
Patch2102: 	linux-2.6-defaults-firmware-loader-timeout.patch
Patch2103: 	linux-2.6-defaults-phys-start.patch
Patch2104:	linux-2.6.19-ueagle-atm-freezer.patch

Patch3000:	loop-AES-v3.2c-2.6.24.patch
Patch4001:	thinkpad-acpi-0.21-20080703_v2.6.26-rc8.patch

Patch4100:	linux-2.6-lirc.patch

# Patches going upstream really soon.
# utrace replaces ptrace() 

# wireless devices for mac80211 stack and fixes
# patch(es) taken from fedora koji kernel packages
# for convenience sake
#Patch5010: linux-2.6-wireless.patch
Patch5011: 	linux-2.6-wireless-pending.patch
#Patch5012: linux-2.6-wireless-fixups.patch
Patch5013: 	linux-2.6-at76.patch

# patch taken from wireless-tools 30pre6 and rediffed
# fixes broken essid scanning behaviour
Patch5020: 	iw262_restore_full_essid.diff


# fixes
Patch9200: 	linux-2.6-e1000-corrupt-eeprom-checksum.patch
Patch9201: 	linux-2.6-netdev-e1000-disable-alpm.patch
Patch9202: 	rtc-wakeup.diff


# powermanagement
Patch9300: 	linux-2.6-wakeups.patch

# diverse addons
# Squashfs support
Patch9900: 	linux-2.6-squashfs.patch

BuildRoot: 	%{_tmppath}/%{name}-buildroot

%description
The kernel package contains the Linux kernel (vmlinuz), the core of any
Linux operating system.  The kernel handles the basic functions
of the operating system: memory allocation, process allocation, device
input and output, etc.


%package headers
Summary: 	Header files for the Linux kernel for use by glibc
Group: 		Development/System
Obsoletes: 	linux-libc-headers
Provides: 	linux-libc-headers

%description headers
Kernel-headers includes the C header files that specify the interface
between the Linux kernel and userspace libraries and programs.  The
header files define structures and constants that are needed for
building most standard programs and are also needed for rebuilding the
glibc package.

#
# This macro creates a kernel-<subpackage>-devel package.
#       %%kernel_devel_package <subpackage> <pretty-name>
#
%define kernel_devel_package() \
%package %{?1:%{1}-}devel\
Summary: Development package for building kernel modules to match the %{?2:%{2} }kernel\
Group: System Environment/Kernel\
Provides: kernel%{?1:-%{1}}-devel-%{_target_cpu} = %{version}-%{release}\
Provides: kernel-devel-%{_target_cpu} = %{version}-%{release}%{?1:.%{1}}\
Provides: kernel-devel = %{version}-%{release}%{?1:.%{1}}\
Provides: kernel-devel-uname-r = %{KVERREL}%{?1:.%{1}}\
AutoReqProv: no\
Requires(pre): /usr/bin/find\
%description -n kernel%{?variant}%{?1:-%{1}}-devel\
This package provides kernel headers and makefiles sufficient to build modules\
against the %{?2:%{2} }kernel package.\
%{nil}


#
# This macro creates a kernel-<subpackage> and its -devel and -debuginfo too.
#       %%define variant_summary The Linux kernel compiled for <configuration>
#       %%kernel_variant_package [-n <pretty-name>] <subpackage>
#
%define kernel_variant_package(n:) \
%package %1\
Summary: %{variant_summary}\
Group: System Environment/Kernel\
%kernel_reqprovconf\
%{expand:%%kernel_devel_package %1 %{!?-n:%1}%{?-n:%{-n*}}}\
%{nil}


# First the auxiliary packages of the main kernel package.
%kernel_devel_package

# Now, each variant package.

%define variant_summary The Linux kernel compiled for SMP machines
%kernel_variant_package -n SMP smp
%description smp
This package includes a SMP version of the Linux kernel. It is
required only on machines with two or more CPUs as well as machines with
hyperthreading technology.

Install the kernel-smp package if your machine uses two or more CPUs.


%define variant_summary The Linux kernel compiled for PAE capable machines
%kernel_variant_package PAE
%description PAE
This package includes a version of the Linux kernel with support for up to
64GB of high memory. It requires a CPU with Physical Address Extensions (PAE).
The non-PAE kernel can only address up to 4GB of memory.
Install the kernel-PAE package if your machine has more than 4GB of memory.



%prep
#%setup -q -n linux-%{kversion}
%setup -q -n linux-%{kversion}.%{subrel}

# honor quiet kerneloption
%patch0 -p1 -b .quiet

# CK optimizations
#%patch1 -p1
# finetune CFS
#%patch2 -p1
#%patch3 -p1
%patch4 -p1
#%patch5 -p1 - rediff ?

# Acer hotkeys
%patch212 -p1 -b .acerhk
# Fujitsu ACPI
%patch214 -p1

# fbcondecor
%patch91002 -p1 

# colored printk output
%patch91003 -p1 

# ReiserFS4 support
%patch7006 -p1

# SKAS support
#%patch7009 -p1

# software suspend2 support
%patch7011 -p1 

# atop extended support
%patch7020 -p1 -b .atop01
%patch7021 -p1 -b .atop02

## Performance tweaks

# Changes to upstream defaults.
# Increase timeout on firmware loader.
#%patch2102 -p1
# Change PHYSICAL_START
#%patch2103 -p1
# Patch freezer error in ueagle-atm
%patch2104 -p0

#loopAES
rm -f drivers/block/loop.c include/linux/loop.h
%patch3000 -p1

# thinkpad acpi extensions
#%patch4000 -p1
%patch4001 -p1

# ALSA 1.0.17 drivers
#%patch8000 -p1

# lirc device drivers
%patch4100 -p1

# utrace ptrace replacement.
# f'cks up skas atm - so we don't patch
#%patch5000 -p1

# Add the new wireless drivers from wireless-dev
# plus fixes
# post-2.6.26 wireless patches from upstream
#%patch5010 -p1
%patch5011 -p1
#%patch5012 -p1 
# at76 driver
%patch5013 -p1

# fix essid behaviour
%patch5020 -p1

# network device fixes
#%patch9200 -p1
%patch9201 -p1
%patch9202 -p1

# power management
%patch9300 -p1

# squashfs 3.3
%patch9900 -p1

mkdir configs

cp -fv %{all_arch_configs} .


# now run oldconfig over all the config files
for i in *.config
do 
	mv $i .config 
	
	# Check for different must have config options
	if [ ! `cat .config | grep "CONFIG_FB_CON_DECOR=y"` ]; then
	    echo "Missing CONFIG_FB_CON_DECOR in .config"
	    exit 1
	fi

	Arch=`head -1 .config | cut -b 3-`
	make ARCH=$Arch oldconfig #> /dev/null
	echo "# $Arch" > configs/$i
	cat .config >> configs/$i 
done

# get rid of unwanted files resulting from patch fuzz
find . \( -name "*.orig" -o -name "*~" \) -exec rm -f {} \; >/dev/null

%build

cp_vmlinux()
{
  eu-strip --remove-comment -o "$2" "$1"
}

BuildKernel() {
    MakeTarget=$1
    KernelImage=$2
    Flavour=$3
    InstallName=${4:-vmlinuz}

    # Pick the right config file for the kernel we're building
    Config=kernel-%{version}-%{_target_cpu}${Flavour:+-${Flavour}}.config
    DevelDir=/usr/src/kernels/%{KVERREL}${Flavour:+.${Flavour}}

    # When the bootable image is just the ELF kernel, strip it.
    # We already copy the unstripped file into the debuginfo package.
    if [ "$KernelImage" = vmlinux ]; then
      CopyKernel=cp_vmlinux
    else
      CopyKernel=cp
    fi

    KernelVer=%{version}-%{release}.%{_target_cpu}${Flavour:+.${Flavour}}
    echo BUILDING A KERNEL FOR ${Flavour} %{_target_cpu}...

    # make sure EXTRAVERSION says what we want it to say
    perl -p -i -e "s/^EXTRAVERSION.*/EXTRAVERSION = -%{release}.%{_target_cpu}${Flavour:+.${Flavour}}/" Makefile


    # and now to start the build process

    make -s mrproper
    cp configs/$Config .config

    Arch=`head -1 .config | cut -b 3-`
    echo USING ARCH=$Arch

    make -s ARCH=$Arch oldconfig > /dev/null
    make -s ARCH=$Arch %{?_smp_mflags} $MakeTarget 
    make -s ARCH=$Arch %{?_smp_mflags} modules  || exit 1

    # Start installing the results

    mkdir -p $RPM_BUILD_ROOT/%{image_install_path}
    install -m 644 .config $RPM_BUILD_ROOT/boot/config-$KernelVer
    install -m 644 System.map $RPM_BUILD_ROOT/boot/System.map-$KernelVer
    if [ -f arch/$Arch/boot/zImage.stub ]; then
      cp arch/$Arch/boot/zImage.stub $RPM_BUILD_ROOT/%{image_install_path}/zImage.stub-$KernelVer || :
    fi
    # FIXME?
    if [ "$KernelImage" == "x86" ]; then
       KernelImage=arch/$Arch/boot/bzImage
    fi

    $CopyKernel $KernelImage \
	       $RPM_BUILD_ROOT/%{image_install_path}/$InstallName-$KernelVer
    chmod 755 $RPM_BUILD_ROOT/%{image_install_path}/$InstallName-$KernelVer

    mkdir -p $RPM_BUILD_ROOT/lib/modules/$KernelVer
    make -s ARCH=$Arch INSTALL_MOD_PATH=$RPM_BUILD_ROOT modules_install KERNELRELEASE=$KernelVer
    make -s ARCH=$Arch INSTALL_MOD_PATH=$RPM_BUILD_ROOT vdso_install KERNELRELEASE=$KernelVer

    # And save the headers/makefiles etc for building modules against
    #
    # This all looks scary, but the end result is supposed to be:
    # * all arch relevant include/ files
    # * all Makefile/Kconfig files
    # * all script/ files

    rm -f $RPM_BUILD_ROOT/lib/modules/$KernelVer/build
    rm -f $RPM_BUILD_ROOT/lib/modules/$KernelVer/source
    mkdir -p $RPM_BUILD_ROOT/lib/modules/$KernelVer/build
    (cd $RPM_BUILD_ROOT/lib/modules/$KernelVer ; ln -s build source)
    # dirs for additional modules per module-init-tools, kbuild/modules.txt
    mkdir -p $RPM_BUILD_ROOT/lib/modules/$KernelVer/extra
    mkdir -p $RPM_BUILD_ROOT/lib/modules/$KernelVer/updates
    mkdir -p $RPM_BUILD_ROOT/lib/modules/$KernelVer/weak-updates
    # first copy everything
    cp --parents `find  -type f -name "Makefile*" -o -name "Kconfig*"` $RPM_BUILD_ROOT/lib/modules/$KernelVer/build
    cp Module.symvers $RPM_BUILD_ROOT/lib/modules/$KernelVer/build
    cp System.map $RPM_BUILD_ROOT/lib/modules/$KernelVer/build
    if [ -s Module.markers ]; then
      cp Module.markers $RPM_BUILD_ROOT/lib/modules/$KernelVer/build
    fi    
    # then drop all but the needed Makefiles/Kconfig files
    rm -rf $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/Documentation
    rm -rf $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/scripts
    rm -rf $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/include
    cp .config $RPM_BUILD_ROOT/lib/modules/$KernelVer/build
    cp -a scripts $RPM_BUILD_ROOT/lib/modules/$KernelVer/build
    if [ -d arch/%{_arch}/scripts ]; then
      cp -a arch/%{_arch}/scripts $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/arch/%{_arch} || :
    fi
    if [ -f arch/%{_arch}/*lds ]; then
      cp -a arch/%{_arch}/*lds $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/arch/%{_arch}/ || :
    fi
    rm -f $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/scripts/*.o
    rm -f $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/scripts/*/*.o
    mkdir -p $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/include
    cd include
    cp -a acpi config keys linux math-emu media mtd net pcmcia rdma rxrpc scsi sound video asm asm-generic $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/include
    cp -a `readlink asm` $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/include
#%if %{includexen}
#    cp -a xen $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/include
#%endif

    # Make sure the Makefile and version.h have a matching timestamp so that
    # external modules can be built
    touch -r $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/Makefile $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/include/linux/version.h
    touch -r $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/.config $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/include/linux/autoconf.h
    # Copy .config to include/config/auto.conf so "make prepare" is unnecessary.
    cp $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/.config $RPM_BUILD_ROOT/lib/modules/$KernelVer/build/include/config/auto.conf
    cd ..

    #
    # save the vmlinux file for kernel debugging into the kernel-debuginfo rpm
    #
#%if "%{_enable_debug_packages}" == "1"
#    mkdir -p $RPM_BUILD_ROOT/usr/lib/debug/lib/modules/$KernelVer
#    cp vmlinux $RPM_BUILD_ROOT/usr/lib/debug/lib/modules/$KernelVer
#%endif

    find $RPM_BUILD_ROOT/lib/modules/$KernelVer -name "*.ko" -type f >modnames

    # mark modules executable so that strip-to-file can strip them
    xargs --no-run-if-empty chmod u+x < modnames

    # Generate a list of modules for block and networking.

    fgrep /drivers/ modnames | xargs --no-run-if-empty nm -upA |
    sed -n 's,^.*/\([^/]*\.ko\):  *U \(.*\)$,\1 \2,p' > drivers.undef

    collect_modules_list()
    {
      sed -r -n -e "s/^([^ ]+) \\.?($2)\$/\\1/p" drivers.undef |
      LC_ALL=C sort -u > $RPM_BUILD_ROOT/lib/modules/$KernelVer/modules.$1
    }

    collect_modules_list networking \
                         'register_netdev|ieee80211_register_hw|usbnet_probe'
    collect_modules_list block \
                         'ata_scsi_ioctl|scsi_add_host|blk_init_queue|register_mtd_blktrans'

    # detect missing or incorrect license tags
    rm -f modinfo
    while read i
    do
      echo -n "${i#$RPM_BUILD_ROOT/lib/modules/$KernelVer/} " >> modinfo
      /sbin/modinfo -l $i >> modinfo
    done < modnames

    egrep -v \
          'GPL( v2)?$|Dual BSD/GPL$|Dual MPL/GPL$|GPL and additional rights$' \
          modinfo && exit 1

    rm -f modinfo modnames

    # remove files that will be auto generated by depmod at rpm -i time
    for i in alias ccwmap dep ieee1394map inputmap isapnpmap ofmap pcimap seriomap symbols usbmap
    do
      rm -f $RPM_BUILD_ROOT/lib/modules/$KernelVer/modules.$i
    done

    # Move the devel headers out of the root file system
    mkdir -p $RPM_BUILD_ROOT/usr/src/kernels
    mv $RPM_BUILD_ROOT/lib/modules/$KernelVer/build $RPM_BUILD_ROOT/$DevelDir
    ln -sf ../../..$DevelDir $RPM_BUILD_ROOT/lib/modules/$KernelVer/build
}


###
# DO it...
###

# prepare directories
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/boot

#cd linux-%{kversion}.%{_target_cpu}

%if %{buildup}
BuildKernel %make_target %kernel_image
%endif

%if %{buildsmp}
BuildKernel %make_target %kernel_image smp
%endif

%if %{buildpae}
BuildKernel %make_target %kernel_image PAE
%endif

%install
#cd linux-%{kversion}.%{_target_cpu}

%if %{buildheaders}
# Install kernel headers
make ARCH=%{hdrarch} INSTALL_HDR_PATH=$RPM_BUILD_ROOT/usr headers_install

# Manually go through the 'headers_check' process for every file, but
# don't die if it fails
chmod +x scripts/hdrcheck.sh
echo -e '*****\n*****\nHEADER EXPORT WARNINGS:\n*****' > hdrwarnings.txt
for FILE in `find $RPM_BUILD_ROOT/usr/include` ; do
    scripts/hdrcheck.sh $RPM_BUILD_ROOT/usr/include $FILE /dev/null >> hdrwarnings.txt || :
done
echo -e '*****\n*****' >> hdrwarnings.txt
if grep -q exist hdrwarnings.txt; then
   sed s:^$RPM_BUILD_ROOT/usr/include/:: hdrwarnings.txt
   # Temporarily cause a build failure if header inconsistencies.
   # exit 1
fi

# glibc provides scsi headers for itself, for now
rm -rf $RPM_BUILD_ROOT/usr/include/scsi
rm -f $RPM_BUILD_ROOT/usr/include/asm*/atomic.h
rm -f $RPM_BUILD_ROOT/usr/include/asm*/io.h
rm -f $RPM_BUILD_ROOT/usr/include/asm*/irq.h
%endif

### pre/post/preun/postun scripts

#
# This macro defines a %%post script for a kernel*-devel package.
#       %%kernel_devel_post <subpackage>
#
%define kernel_devel_post() \
%{expand:%%post %{?1:%{1}-}devel}\

%{nil}

#
# This macro defines a %%posttrans script for a kernel package.
#       %%kernel_variant_posttrans [-v <subpackage>] [-s <s> -r <r>] <mkinitrd-args>
# More text can follow to go at the end of this variant's %%post.
#
%define kernel_variant_posttrans(s:r:v:) \
%{expand:%%posttrans %{?-v*}}\

%{nil}

#
# This macro defines a %%post script for a kernel package and its devel package.
#       %%kernel_variant_post [-v <subpackage>] [-s <s> -r <r>] <mkinitrd-args>
# More text can follow to go at the end of this variant's %%post.
#
%define kernel_variant_post(s:r:v:) \
%{expand:%%kernel_devel_post %{?-v*}}\
%{expand:%%kernel_variant_posttrans %{?-v*}}\
%{expand:%%post %{?-v*}}\
### Refresh module dependencies database\
/sbin/depmod -a -F /boot/System.map-%{KVERREL}%{?-v:.%{-v*}} %{KVERREL}%{?-v:.%{-v*}} >/dev/null 2>&1 ||:\
### Build initramfs\
/usr/sbin/ccux-geninitramfs -k %{KVERREL}%{?-v:.%{-v*}} -f >/dev/null 2>&1 ||:\
### Create symlinks\
ln -sf initramfs-%{KVERREL}%{?-v:.%{-v*}}.cpio.gz /boot/initramfs >/dev/null 2>&1 ||:\
ln -sf System.map-%{KVERREL}%{?-v:.%{-v*}} /boot/System.map >/dev/null 2>&1 ||:\
ln -sf vmlinuz-%{KVERREL}%{?-v:.%{-v*}} /boot/vmlinuz >/dev/null 2>&1 ||:\
%{nil}

#
# This macro defines a %%preun script for a kernel package.
#       %%kernel_variant_preun <subpackage>
#
%define kernel_variant_preun() \
%{expand:%%preun %{?1}}\
rm -rf /boot/initramfs-%{KVERREL}%{?1:.%{1}}.cpio.gz ||:\
%{nil}

%kernel_variant_preun
%kernel_variant_post -s kernel-smp -r kernel

%kernel_variant_preun smp
%kernel_variant_post -v smp

%kernel_variant_preun PAE
%kernel_variant_post -v PAE -s kernel-smp -r kernel-PAE



###
### file lists
###

%if %{buildheaders}
%files headers
%defattr(-,root,root)
/usr/include/*
%endif

# This is %{image_install_path} on an arch where that includes ELF files,
# or empty otherwise.
%define elf_image_install_path %{?kernel_image_elf:%{image_install_path}}

#
# This macro defines the %%files sections for a kernel package
# and its devel and debuginfo packages.
#       %%kernel_variant_files [-k vmlinux] [-a <extra-files-glob>] [-e <extra-nonbinary>] <condition> <subpackage>
#
%define kernel_variant_files(a:e:k:) \
%if %{1}\
%{expand:%%files %{?2}}\
%defattr(-,root,root)\
/%{image_install_path}/%{?-k:%{-k*}}%{!?-k:vmlinuz}-%{KVERREL}%{?2:.%{2}}\
/boot/System.map-%{KVERREL}%{?2:.%{2}}\
/boot/config-%{KVERREL}%{?2:.%{2}}\
%{?-a:%{-a*}}\
%dir /lib/modules/%{KVERREL}%{?2:.%{2}}\
/lib/modules/%{KVERREL}%{?2:.%{2}}/kernel\
/lib/modules/%{KVERREL}%{?2:.%{2}}/build\
/lib/modules/%{KVERREL}%{?2:.%{2}}/source\
/lib/modules/%{KVERREL}%{?2:.%{2}}/extra\
/lib/modules/%{KVERREL}%{?2:.%{2}}/updates\
/lib/modules/%{KVERREL}%{?2:.%{2}}/weak-updates\
/lib/modules/%{KVERREL}%{?2:.%{2}}/vdso\
/lib/modules/%{KVERREL}%{?2:.%{2}}/modules.block\
/lib/modules/%{KVERREL}%{?2:.%{2}}/modules.networking\
/lib/modules/%{KVERREL}%{?2:.%{2}}/modules.order\
#%ghost /boot/initramfs-%{KVERREL}%{?2:.%{2}}.cpio.gz\
%{?-e:%{-e*}}\
%{expand:%%files %{?2:%{2}-}devel}\
%defattr(-,root,root)\
%verify(not mtime) /usr/src/kernels/%{KVERREL}%{?2:.%{2}}\
#/usr/src/kernels/%{KVERREL}%{?2:.%{2}}\
%endif\
%{nil}


%kernel_variant_files 1
%kernel_variant_files 0 smp
%kernel_variant_files 1 PAE


%clean
rm -rf $RPM_BUILD_ROOT

%changelog
* Fri Aug 29 2008 Christian Metzen <metzench@ccux-linux.de> 2.6.26-9
- added rtc-wakeup patch
* Thu Aug 21 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.26-8
- kernel 2.6.26.3
- v4l-dvb patchset for Hauppauge DVB cards 20080626 
* Thu Aug 07 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.26-7
- kernel 2.6.26.2
* Wed Aug 06 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.26-6
- kernel 2.6.26.1
* Fri Jul 25 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.26-5
- refined Provides
- alsa driver 1.0.17
- tuxonice 3.0-rc7a
* Wed Jul 23 2008 Christian Metzen <metzench@ccux-linux.de> 2.6.26-4
- added some packages to kernel_prereq
* Sun Jul 20 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.26-3
- fixed plain kernel config (accidentally PAE config sneaked in)
- reintroduced target_cpu
* Sat Jul 19 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.26-2
- fixed post scriplets (symlinks, initramfs generation)
- fixed preun scriplets (delete old initramfs, so /boot doesn't get cluttered)
- proper separation between different kernel flavor configs
* Mon Jul 14 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.26-1
- kernel 2.6.26
* Thu Jul 03 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.25-15
- kernel 2.6.25.10
* Mon Jun 30 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.25-14
- thinkpad-acpi 0.21 20080629
* Mon Jun 30 2008 Christian Metzen <metzench@ccux-linux.de> 2.6.25-13
- remove conflicting CONFIG_RTC from config file
* Wed Jun 25 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.25-12
- kernel 2.6.25.9
* Sun Jun 22 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.25-11
- kernel 2.6.25.8
- thinkpad-acpi 0.21 20080621
* Tue Jun 17 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.25-10
- kernel 2.6.25.7
- alsa 1.0.17rc2
* Tue Jun 10 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.25-9
- kernel 2.6.25.6
* Sat Jun 07 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.25-8
- kernel 2.6.25.5
- alsa 1.0.17rc1
* Fri May 16 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.25-7
- kernel 2.6.25.4
- rediffed lirc patch to 0.8.3
* Sat May 10 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.25-6
- kernel 2.6.25.3
* Wed May 07 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.25-5
- kernel 2.6.25.2
* Fri May 02 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.25-4
- kernel 2.6.25.1
- reenabled accidentally disabled reiser4 support
- tuxonice 3.0-rc7
* Thu Apr 17 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.25-3
- kernel 2.6.25 final
- temp. disabled skas4, acerhk, ck-optimizations
* Sun Apr 13 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.25-2
- kernel 2.6.25-rc9
* Wed Mar 26 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.24-11
- kernel 2.6.24.4
- skas4
* Fri Mar 14 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.25-1
- kernel 2.6.25-rc5
* Fri Mar 14 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.24-10
- kernel 2.6.24.3
* Fri Jan 25 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.24-9
- kernel 2.6.24
- tuxonice 3.0-rc5
* Thu Jan 17 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.24-8
- kernel 2.6.24-rc8
- thinkpad-acpi 0.19
- dropped ipw3945 patch, use iwlwifi instead
* Mon Jan 07 2008 Karsten Brockmann <arcam@ccux-linux.de> 2.6.24-7
- kernel 2.6.24-rc7
* Sun Dec 30 2007 Christian Metzen <metzench@ccux-linux.de> 2.6.24-6
- added CONFIG_FB_CON_DECOR check in kernel config
* Fri Dec 21 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.24-5
- kernel 2.6.24-rc6
- added relatime as default mount option
- added mtune=generic for more optimized builds
* Thu Dec 13 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.24-4
- kernel 2.6.24-rc5
* Sat Dec 08 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.24-3
- revised lirc patch
* Tue Dec 04 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.24-2
- kernel 2.6.24-rc4
- tuxonice 3.0-rc3
- integrated lirc drivers
- ondemand now default governor
* Sat Nov 24 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.24-1
- Kernel 2.6.24-rc3
- CFS v24
- tuxonice 3.0-rc2
- loopAES 3.2b
- thinkpad-acpi 0.18
* Sat Nov 17 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.23-8
- Kernel 2.6.23.8
* Sat Oct 27 2007 Christian Metzen <metzench@ccux-linux.de> 2.6.23-7
- ccux-geninitramfs integration
* Wed Oct 24 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.23-6
- disabled old IDE support in favour of libata
- alsa 1.0.15
* Fri Oct 12 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.23-5
- kernel 2.6.23.1
- revised reiser4 patch
- tuxonice 3.0-rc1
* Thu Oct 11 2007 Christian Metzen <metzench@ccux-linux.de> 2.6.23-4
- added fbcondecor patch
* Thu Oct 11 2007 Christian Metzen <metzench@ccux-linux.de> 2.6.23-3
- modified kernel colors to 0x02 ( green on black )
* Thu Oct 11 2007 Christian Metzen <metzench@ccux-linux.de> 2.6.23-2
- removed bootsplash
- added kernel colors patch
* Wed Oct 10 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.23-1
- Version update
- Kernel 2.6.23
- tuxonice 2.2.10.4 (was: suspend2)
* Sat Sep 29 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.22-9
- Kernel 2.6.22.9
* Sat Sep 22 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.22-8
- Kernel 2.6.22.7
* Sat Sep 01 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.22-7
- Version update
- Kernel 2.6.22.6
- CFS V20.5
* Thu Aug 30 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.22-6
- Version update
- Kernel 2.6.22.5
* Tue Aug 21 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.22-5
- Version update
- Kernel 2.6.22.4
* Thu Aug 16 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.22-4
- Version update
- Kernel 2.6.22.3
* Tue Aug 14 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.22-3
- Version update
- Kernel 2.6.22.2
* Sat Jul 14 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.22-2
- Version update
- Kernel 2.6.22.1
- temporarily dropped skas patch
- uvesafb 0.1rc3
- UDF 2.50
- thinkpad-acpi 
* Mon Jul 09 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.22-1
- Version update
- Kernel 2.6.22
- CFS V19
- suspend2 2.2.10.2
- loop-AES 3.2a
* Sat Jul 07 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.21-6
- Version update
- Kernel 2.6.21.6
* Thu Jun 14 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.21-5
- Version update
- Kernel 2.6.21.5
* Sat Jun 09 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.21-4
- Version update
- Kernel 2.6.21.4
- suspend2 2.2.10
* Sun May 27 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.21-3
- Version update
- Kernel 2.6.21.3
- added Intel timer rounding patch
- added hdaps timer patch
- SIS 900 fix is now upstream - removed patch
* Thu May 03 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.21-2
- Version update
- Kernel 2.6.21.1
- added SIS 900 fix
* Thu Apr 26 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.21-1
- Version update
- Kernel 2.6.21
- suspend2-2.2.9.13
- integrated git-version of mac80211 aka devicescape wireless stack
* Sat Apr 07 2007  Karsten Brockmann <arcam@ccux-linux.de> 2.6.20-7
- Kernel 2.6.20.6
- loop-AES v3.1f
* Sat Mar 24 2007  Karsten Brockmann <arcam@ccux-linux.de> 2.6.20-6
- Kernel 2.6.20.4
- configured LZF compression support from module into kernel
* Wed Mar 14 2007  Karsten Brockmann <arcam@ccux-linux.de> 2.6.20-5
- Kernel 2.6.20.3
- configured ESS18xx module support
* Sat Feb 24 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.20-4
- configured Macintosh partition support (needed for Mac formated
  Ipods)
- configured Linux Security Modules (LSM)
* Tue Feb 20 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.20-3
- Kernel 2.6.20.1
* Sat Feb 17 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.20-2
- ck patchset 2.6.20-ck1
- suspend2-2.2.9.7
- acerhk 0.5.35
- skas 2.6.20-v9-pre9
* Sun Feb 04 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.20-1
- Kernel 2.6.20
- ck patchset 2.6.20-rc6-ck1
- suspend2 2.2.9.3
* Thu Jan 11 2007 Karsten Brockmann <arcam@ccux-linux.de> 2.6.19-6
- Kernel 2.6.19.2
- added backport of HUAWEI UMTS modem fixes from 2.6.20rc4
* Sat Dec 30 2006 Christian Metzen <metzench@ccux-linux.de> 2.6.19-5
- added kernel headers package
* Sun Dec 17 2006 Christian Metzen <metzench@ccux-linux.de> 2.6.19-4
- removed unionfs and squashfs patches, added loopAES
* Wed Dec 10 2006 Karsten Brockmann <arcam@ccux-linux.de> 2.6.19-3
- Kernel 2.6.19.1
- cleaned up patches
* Sun Dec 10 2006 Karsten Brockmann <arcam@ccux-linux.de> 2.6.19-2
- (re)added Reiser4 support
- added EFI partition support
* Sun Dec 10 2006 Stefan Gottwald <gotti@ccux-linux.de> 2.6.19-1
- Kernel 2.6.19
- suspend2 2.2.9
- unionfs 2.6.19 patch
- vesafb-tng-1.0-rc2
- skas-2.6.19-rc6-v9-pre9
* Sat Oct 28 2006 Karsten Brockmann <arcam@ccux-linux.de> 2.6.18-4
- set FAT_DEFAULT_IOCHARSET to cp1250 (fixes umlauts on fat/ntfs partitions)
* Thu Oct 26 2006 Christian Metzen <metzench@ccux-linux.de> 2.6.18-3
- removed 64G mem config ( including PAE ), seems to cause trouble sometimes
* Mon Oct 22 2006 Karsten Brockmann <arcam@ccux-linux.de> 2.6.18-2
- Kernel 2.6.18.1
* Sun Oct 01 2006 Karsten Brockmann <arcam@ccux-linux.de> 2.6.18-1
- Kernel 2.6.18
- suspend2 2.2.8
- sqashfs 3.1r2
- unionfs 20060916-2203
- vesafb-tng-1.0-rc2-git-20060629
- skas-fremap-v9-pre9
* Fri Aug 24 2006 Karsten Brockmann <arcam@ccux-linux.de> 2.6.17-3
- Kernel 2.6.17.11
- squashfs 3.1
- reiser4 for 2.6.17-3
* Wed Aug 09 2006 Karsten Brockmann <arcam@ccux-linux.de> 2.6.17-2
- Kernel 2.6.17.8
* Fri Jul 07 2006 Karsten Brockmann <arcam@ccux-linux.de> 2.6.17-1
- Kernel 2.6.17.4
- ck patchset update
* Thu Jun 08 2006 Christian Metzen <metzench@ccux-linux.de> 2.6.16-6
- Kernel 2.6.16.20
- ck patchset update
* Sat May 13 2006 Christian Metzen <metzench@ccux-linux.de> 2.6.16-5
- Kernel 2.6.16.14
- patchset updates
- modified kernel config for iptables support, Bug #0000149
* Tue May 02 2006 Christian Metzen <metzench@ccux-linux.de> 2.6.16-4
- Kernel 2.6.16.12
- removed madwifi, separated into own package
- rewdefined config, added smp support and more
* Tue Apr 18 2006 Christian Metzen <metzench@ccux-linux.de> 2.6.16-3
- Cleaned specfile
- Added provides for target arch
* Mon Apr 17 2006 Christian Metzen <metzench@ccux-linux.de> 2.6.16-2
- added unionfs and reiser4 patches
* Tue Apr 04 2006 Christian Metzen <metzench@ccux-linux.de> 2.6.16-1
- Version update
- update skas patch
- removed ndiswrapper, will be in seperate package again
- updated squashfs to 3.0
- removed acx patches
* Fri Feb 17 2006 Christian Metzen <metzench@ccux-linux.de> 2.6.15-11
- ndiswrapper update to 1.10
* Thu Feb 16 2006 Christian Metzen <metzench@ccux-linux.de> 2.6.15-10
- Added Gottis new ndiswrapper Patch and Update
- Kernel 2.6.15.4, ck patchset update
* Sat Jan 28 2006 Karsten Brockmann <arcam@ccux-linux.de> 2.6.15-9
- added modules for CS4231/2, SB16, SB_AWE ISA-Chipsets
- added I2O SCSI Chipset module
* Wed Jan 25 2006 Christian Metzen <metzench@ccux-linux.de> 2.6.15-8
- minor patchset update
* Thu Jan 19 2006 Christian Metzen <metzench@ccux-linux.de> 2.6.15-7
- ck Patch update, kernel 2.6.15.1
* Sat Jan 14 2006 Christian Metzen <metzench@ccux-linux.de> 2.6.15-6
- readded ck patch, fglrx module needs to be patched, added missing .cpu file to devel package
* Thu Jan 12 2006 Christian Metzen <metzench@ccux-linux.de> 2.6.15-5
- temp ck patch removement
* Wed Jan 11 2006 Christian Metzen <metzench@ccux-linux.de> 2.6.15-4
- Modified ndiswrapper patch
* Thu Jan 05 2006 Christian Metzen <metzench@ccux-linux.de> 2.6.15-3
- Readded acx1xx patch
- Readded skas patch
* Thu Jan 05 2006 Christian Metzen <metzench@ccux-linux.de> 2.6.15-2
- New bootsplash Patch
* Thu Jan 05 2006 Christian Metzen <metzench@ccux-linux.de> 2.6.15-1
- Removed some patches, ndis update
- removed ipw seperate drivers, now upstream
- removed bluez patch, now upstream?
- removed acx100 patch
* Thu Oct 13 2005 Christian Metzen <metzench@ccux-linux.de> 2.6.13-8
- Fixed major Bug in skas Patch
* Thu Oct 13 2005 Christian Metzen <metzench@ccux-linux.de> 2.6.13-7
- Patchset updates, activated ndis and other lately added patches in the kernel config
* Thu Oct 06 2005 Stefan Gottwald <gotti@ccux-linux.de> 2.6.13-6
- Activate I2O Raid Device Support, added UML SKAS Patch
- Make the ndiswrapper patch working, it is only a Workaround
* Fri Sep 23 2005 Christian Metzen <metzench@ccux-linux.de> 2.6.13-5
- Recent Patchset updates
* Sat Sep 17 2005 Christian Metzen <metzench@ccux-linux.de> 2.6.13-4
- Recent Pactset updates
* Mon Sep 05 2005 Christian Metzen <metzench@ccux-linux.de> 2.6.13-3
- Patchset update, some finetuning
* Sun Sep 04 2005 Christian Metzen <metzench@ccux-linux.de> 2.6.13-2
- Switched alsa to fully module
* Sat Sep 03 2005 Christian Metzen <metzench@ccux-linux.de> 2.6.13-1
- Version update
* Sat Aug 13 2005 Christian Metzen <metzench@ccux-linux.de> 2.6.12-11
- Some Patchset updates
* Thu Jul 14 2005 Christian Metzen <metzench@ccux-linux.de> 2.6.12-10
- Removed latest nv update Patches
* Mon Jul 11 2005 Christian Metzen <metzench@ccux-linux.de> 2.6.12-9
- Added nv update Patches, new madwifi driver
* Sat Jul 02 2005 Christian Metzen <metzench@ccux-linux.de> 2.6.12-8
- Modified config
* Sat Jul 02 2005 Christian Metzen <metzench@ccux-linux.de> 2.6.12-7
- Modified config
* Thu Jun 30 2005 Christian Metzen <metzench@ccux-linux.de> 2.6.12-6
- Added sk98lin Patch, updated to ck3 / 2.6.12.2
* Thu Jun 30 2005 Christian Metzen <metzench@ccux-linux.de> 2.6.12-5
- Fixed minor Bug, removed rivafb Module from config
* Thu Jun 30 2005 Christian Metzen <metzench@ccux-linux.de> 2.6.12-4
- Added some Requires
* Tue Jun 28 2005 Christian Metzen <metzench@ccux-linux.de> 2.6.12-3
- Removed fbsplash, instead added bootsplash
* Tue Jun 28 2005 Christian Metzen <metzench@ccux-linux.de> 2.6.12-2
- Fixed some minor Bugs
* Mon Jun 27 2005 Christian Metzen <metzench@ccux-linux.de> 2.6.12-1
- Version update to 2.6.12
- Completely rebuild specfile, added support for different Kernel Archs
